]> arthur.barton.de Git - ngircd-alex.git/blobdiff - contrib/platformtest.sh
Update Xcode project for latest Xcode version (10.0)
[ngircd-alex.git] / contrib / platformtest.sh
index e7e5ffe1d19b93345472b14da5c9766d31904e77..e054d06f05d47a5c4059eec5e66180d7a3ff2f98 100755 (executable)
@@ -1,7 +1,7 @@
 #!/bin/sh
 #
 # ngIRCd -- The Next Generation IRC Daemon
-# Copyright (c)2001-2014 Alexander Barton (alex@barton.de) and Contributors
+# Copyright (c)2001-2016 Alexander Barton (alex@barton.de) and Contributors
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # suitable for inclusion in doc/Platforms.txt -- please send reports
 # to the ngIRCd mailing list: <ngircd-ml@ngircd.barton.de>.
 
-NAME=`basename "$0"`
+NAME=$(basename "$0")
 VERBOSE=
 CLEAN=1
 
 PLATFORM=
 COMPILER="unknown"
 VERSION="unknown"
-DATE=`date "+%y-%m-%d"`
+DATE=$(date "+%y-%m-%d")
 COMMENT=
 
 R_CONFIGURE=
@@ -30,7 +30,7 @@ R_CHECK=
 R_CHECK_Y="?"
 R_RUN=
 
-SRC_D=`dirname "$0"`
+SRC_D=$(dirname "$0")
 MY_D="$PWD"
 
 [ -n "$MAKE" ] || MAKE="make"
@@ -55,6 +55,11 @@ while [ $# -gt 0 ]; do
        shift
 done
 
+for cmd in telnet expect; do
+       command -v "$cmd" >/dev/null 2>&1 \
+               || echo "$NAME: WARNING: $cmd(1) not found, \"make check\" won't run all tests!"
+done
+
 echo "$NAME: Checking ngIRCd base source directory ..."
 grep "ngIRCd" "$SRC_D/ChangeLog" >/dev/null 2>&1
 if [ $? -ne 0 ]; then
@@ -72,10 +77,14 @@ echo "$NAME: Checking for GIT tree ..."
 if [ -d "$SRC_D/.git" ]; then
        echo "$NAME: Checking for \"git\" command ..."
        git version >/dev/null 2>&1
-       if [ $? -eq 0 -a -n "$CLEAN" ]; then
+       if [ $? -eq 0 ] && [ -n "$CLEAN" ]; then
                echo "$NAME: Running \"git clean\" ..."
                cd "$SRC_D" || exit 1
-               [ -n "$VERBOSE" ] && git clean -dxf || git clean -dxf >/dev/null
+               if [ -n "$VERBOSE" ]; then
+                       git clean -dxf
+               else
+                       git clean -dxf >/dev/null
+               fi
                cd "$MY_D" || exit 1
        fi
 fi
@@ -84,21 +93,42 @@ echo "$NAME: Checking for \"$SRC_D/configure\" script ..."
 if [ ! -r "$SRC_D/configure" ]; then
        echo "$NAME: Running \"$SRC_D/autogen.sh\" ..."
        cd "$SRC_D" || exit 1
-       [ -n "$VERBOSE" ] && ./autogen.sh || ./autogen.sh >/dev/null
+       if [ -n "$VERBOSE" ]; then
+               ./autogen.sh
+       else
+               ./autogen.sh >/dev/null
+       fi
+       if [ $? -ne 0 ]; then
+               echo "$NAME: \"$SRC_D/autogen.sh\" script failed, aborting!"
+               exit 1
+       fi
        cd "$MY_D" || exit 1
 fi
 
 if [ -r "$SRC_D/configure" ]; then
        echo "$NAME: Running \"$SRC_D/configure\" script ..."
-       [ -n "$VERBOSE" ] && "$SRC_D/configure" -C || "$SRC_D/configure" -C >/dev/null
-       if [ $? -eq 0 -a -r ./Makefile ]; then
+       if [ -n "$VERBOSE" ]; then
+               "$SRC_D/configure" -C
+       else
+               "$SRC_D/configure" -C >/dev/null
+       fi
+       if [ $? -eq 0 ] && [ -r ./Makefile ]; then
                R_CONFIGURE=1
+               rm -f "src/ngircd/ngircd"
                echo "$NAME: Running \"$MAKE\" ..."
-               [ -n "$VERBOSE" ] && "$MAKE" || "$MAKE" >/dev/null
-               if [ $? -eq 0 -a -x src/ngircd/ngircd ]; then
+               if [ -n "$VERBOSE" ]; then
+                       "$MAKE"
+               else
+                       "$MAKE" >/dev/null
+               fi
+               if [ $? -eq 0 ] && [ -x src/ngircd/ngircd ]; then
                        R_MAKE=1
                        echo "$NAME: Running \"$MAKE check\" ..."
-                       [ -n "$VERBOSE" ] && "$MAKE" check || "$MAKE" check >/dev/null
+                       if [ -n "$VERBOSE" ]; then
+                               "$MAKE" check
+                       else
+                               "$MAKE" check >/dev/null
+                       fi
                        if [ $? -eq 0 ]; then
                                R_CHECK=1
                                R_RUN=$R_CHECK
@@ -115,13 +145,13 @@ fi
 
 # Get target platform information
 if [ -r "src/config.h" ]; then
-       CPU=`grep "HOST_CPU" "src/config.h" | cut -d'"' -f2`
-       OS=`grep "HOST_OS" "src/config.h" | cut -d'"' -f2`
-       VENDOR=`grep "HOST_VENDOR" "src/config.h" | cut -d'"' -f2`
+       CPU=$(grep "HOST_CPU" "src/config.h" | cut -d'"' -f2)
+       OS=$(grep "HOST_OS" "src/config.h" | cut -d'"' -f2)
+       VENDOR=$(grep "HOST_VENDOR" "src/config.h" | cut -d'"' -f2)
        PLATFORM="$CPU/$VENDOR/$OS"
 fi
 if [ -z "$PLATFORM" ]; then
-       PLATFORM="`uname 2>/dev/null` `uname -r 2>/dev/null`, `uname -m 2>/dev/null`"
+       PLATFORM="$(uname 2>/dev/null) $(uname -r 2>/dev/null), $(uname -m 2>/dev/null)"
 fi
 
 # Get compiler information
@@ -153,8 +183,8 @@ if [ -r "Makefile" ]; then
                          | cut -d'(' -f1 | sed -e 's/version //g')
                fi
                if [ "$COMPILER" = "unknown" ]; then
-                       v="`$CC --version 2>/dev/null | head -1`"
-                       [ -z "$v" ] && v="`$CC -version 2>/dev/null | head -1`"
+                       v="$($CC --version 2>/dev/null | head -1)"
+                       [ -z "$v" ] && v="$($CC -version 2>/dev/null | head -1)"
                        [ -n "$v" ] && COMPILER="$v"
                fi
        fi
@@ -164,7 +194,7 @@ fi
 eval "$(grep "^VERSION = " Makefile | sed -e 's/ //g')"
 case "$VERSION" in
        *~*-*)
-               VERSION=`echo "$VERSION" | cut -b1-10`
+               VERSION=$(echo "$VERSION" | cut -b1-10)
                ;;
 esac
 [ -n "$VERSION" ] || VERSION="unknown"
@@ -184,7 +214,12 @@ fi
 [ -n "$R_CONFIGURE" ] && C="Y" || C="N"
 [ -n "$R_MAKE" ] && M="Y" || M="N"
 [ -n "$R_CHECK" ] && T="$R_CHECK_Y" || T="N"
-[ -n "$R_RUN" ] && R="Y" || R="N"
+if [ -n "$R_RUN" ]; then
+       # Mark "runs" with "Y" only when the test suite succeeded:
+       [ "$T" = "N" ] && R="?" || R="Y"
+else
+       R="N"
+fi
 [ -n "$COMMENT" ] && COMMENT=" $COMMENT"
 
 echo
@@ -195,17 +230,29 @@ echo "                                                  ./configure works --+ |
 echo "                                                                      | | | |"
 echo "Platform                    Compiler     ngIRCd     Date     Tester   C M T R *"
 echo "--------------------------- ------------ ---------- -------- -------- - - - - -"
-type printf >/dev/null 2>&1
+command -v printf >/dev/null 2>&1
 if [ $? -eq 0 ]; then
        printf "%-27s %-12s %-10s %s %-8s %s %s %s %s%s\n" \
-        "$PLATFORM" "$COMPILER" "$VERSION" "$DATE" "$USER" \
+        "$PLATFORM" "$COMPILER" "$VERSION" "$DATE" "$LOGNAME" \
         "$C" "$M" "$T" "$R" "$COMMENT"
 else
-       echo "$PLATFORM $COMPILER $VERSION $DATE $USER" \
+       echo "$PLATFORM $COMPILER $VERSION $DATE $LOGNAME" \
         "$C" "$M" "$T" "$R" "$COMMENT"
 fi
 echo
+
+double_check() {
+       echo "Please double check that the ngIRCd daemon starts up, runs and handles IRC"
+       echo "connections successfully!"
+}
+
 if [ "$R_CHECK_Y" = "y" ]; then
-       echo "$NAME: Warning: Some tests have been skipped!"
+       echo "WARNING: Some tests have been skipped!"
+       double_check
+       echo
+fi
+if [ "$R" = "?" ]; then
+       echo "WARNING: The resulting binary passed simple tests, but the test suite failed!"
+       double_check
        echo
 fi